#include <R.h>
#include "LSAP.h"
void perm_min_rel_error(int *k, double *ref_w, double *ref_mu, double *ref_sigma2, 
									      double *w, double *mu, double *sigma2, int *label){  
  int j, l;
	double **C;
  C = Calloc(*k, double *);  
  for(j = 0; j < *k; j++){
    C[j] = Calloc(*k, double);
  } 
  for(j = 0; j < *k; j++){
		for(l = 0; l < *k; l++){
			C[l][j] += fabs((ref_w[l] - w[j])/ref_w[l]); 
			C[l][j] += fabs((ref_mu[l] - mu[j])/ref_mu[l]);
			C[l][j] += fabs((ref_sigma2[l] - sigma2[j])/ref_sigma2[l]);
		}
	}      
  /* Solving the assignment problem via the Hungarian method: from R (library clue)*/
  solve_LSAP(C, *k, label);
	for(j = 0; j < *k; j++){
		Free(C[j]);    
	}
	Free(C);	
}